=== src/arch/CMakeLists.txt ===
add_library(arch x86_64.cpp)
