## bpftrace 0.8+git60-gccac69c2239b

=== debian/changelog ===
bpftrace (0.8+git60-gccac69c2239b-2) unstable; urgency=medium

  * d/patches: add patch to avoid optimizing away BEGIN/END trigger
    functions.
  * d/patches: add patch to correctly detect kernel headers.

 -- Vincent Bernat <bernat@debian.org>  Fri, 22 Feb 2019 06:10:27 -0800

bpftrace (0.8+git60-gccac69c2239b-1) unstable; urgency=medium

  * Initial import. Closes: #918120.

 -- Vincent Bernat <bernat@debian.org>  Sun, 03 Feb 2019 12:53:21 +0100
