## bpftrace 0.9

=== debian/changelog ===
bpftrace (0.9-1) unstable; urgency=medium

  * New upstream release.
  * d/patches: drop all patches, applied upstream.

 -- Vincent Bernat <bernat@debian.org>  Sat, 16 Mar 2019 19:07:56 +0100
