## bpftrace 0.9.2

=== debian/changelog ===
bpftrace (0.9.2-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Bernat <bernat@debian.org>  Thu, 01 Aug 2019 09:06:56 +0200

bpftrace (0.9.1-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Bernat <bernat@debian.org>  Wed, 26 Jun 2019 08:31:30 +0200
