=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,18 +1,26 @@
+if(HAVE_BFD_DISASM)
+  set(BFD_DISASM_SRC bfd-disasm.cpp)
+endif()
+
 add_executable(bpftrace
   attached_probe.cpp
   bpftrace.cpp
+  btf.cpp
   clang_parser.cpp
   driver.cpp
   fake_map.cpp
+  list.cpp
   main.cpp
   map.cpp
   mapkey.cpp
+  output.cpp
   printf.cpp
   resolve_cgroupid.cpp
   tracepoint_format_parser.cpp
   types.cpp
   utils.cpp
-  list.cpp
+  disasm.cpp
+  ${BFD_DISASM_SRC}
 )
 
 if(HAVE_NAME_TO_HANDLE_AT)
@@ -24,6 +32,30 @@
 if(HAVE_BCC_CREATE_MAP)
   target_compile_definitions(bpftrace PRIVATE HAVE_BCC_CREATE_MAP)
 endif(HAVE_BCC_CREATE_MAP)
+if(HAVE_BCC_ELF_FOREACH_SYM)
+  target_compile_definitions(bpftrace PRIVATE HAVE_BCC_ELF_FOREACH_SYM)
+endif(HAVE_BCC_ELF_FOREACH_SYM)
+if(HAVE_GET_CURRENT_CGROUP_ID)
+  target_compile_definitions(bpftrace PRIVATE HAVE_GET_CURRENT_CGROUP_ID)
+endif(HAVE_GET_CURRENT_CGROUP_ID)
+if (LIBBPF_BTF_DUMP_FOUND)
+  target_compile_definitions(bpftrace PRIVATE HAVE_LIBBPF_BTF_DUMP)
+  target_include_directories(bpftrace PUBLIC ${LIBBPF_INCLUDE_DIRS})
+  target_link_libraries(bpftrace ${LIBBPF_LIBRARIES})
+endif(LIBBPF_BTF_DUMP_FOUND)
+if(HAVE_BFD_DISASM)
+  target_compile_definitions(bpftrace PRIVATE HAVE_BFD_DISASM)
+  if(LIBBFD_DISASM_FOUR_ARGS_SIGNATURE)
+    target_compile_definitions(bpftrace PRIVATE LIBBFD_DISASM_FOUR_ARGS_SIGNATURE)
+  endif(LIBBFD_DISASM_FOUR_ARGS_SIGNATURE)
+  target_link_libraries(bpftrace ${LIBBFD_LIBRARIES})
+  target_link_libraries(bpftrace ${LIBOPCODES_LIBRARIES})
+endif(HAVE_BFD_DISASM)
+
+if (ALLOW_UNSAFE_UPROBE)
+  target_compile_definitions(bpftrace PRIVATE HAVE_UNSAFE_UPROBE)
+endif(ALLOW_UNSAFE_UPROBE)
+
 target_link_libraries(bpftrace arch ast parser resources)
 
 if (STATIC_LINKING)
@@ -44,10 +76,18 @@
 endif()
 
 execute_process(
-  COMMAND git describe --abbrev=4 --dirty --always --tags
+  COMMAND git describe --abbrev=4 --dirty --tags
   WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
   OUTPUT_VARIABLE BPFTRACE_VERSION
+  ERROR_VARIABLE GIT_DESCRIBE_ERROR
   OUTPUT_STRIP_TRAILING_WHITESPACE
+  RESULT_VARIABLE retcode
 )
 
+# If the build is not done from a git repo, get the version information from
+# the version variables in main CMakeLists.txt
+if(NOT "${retcode}" STREQUAL "0")
+  set(BPFTRACE_VERSION "v${bpftrace_VERSION_MAJOR}.${bpftrace_VERSION_MINOR}.${bpftrace_VERSION_PATCH}")
+endif()
+
 add_definitions("-DBPFTRACE_VERSION=\"${BPFTRACE_VERSION}\"")
