=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,31 +1,53 @@
 add_compile_options("-Wno-undef")
 add_compile_options("-Wno-switch-default")
 add_compile_options("-Wno-switch-enum")
+
+# Combine all codegen tests into a single compilation unit to improve build
+# performance. https://github.com/iovisor/bpftrace/issues/229
+function(generate_codegen_includes output)
+  file(GLOB tests codegen/*.cpp)
+  file(WRITE ${output} "")
+  foreach(test ${tests})
+    file(APPEND ${output} "#include \"${test}\"\n")
+  endforeach()
+endfunction()
+
+if(HAVE_BFD_DISASM)
+  set(BFD_DISASM_SRC ${CMAKE_SOURCE_DIR}/src/bfd-disasm.cpp)
+endif()
+
+generate_codegen_includes(${CMAKE_BINARY_DIR}/tests/codegen_includes.cpp)
 
 add_executable(bpftrace_test
   ast.cpp
   bpftrace.cpp
   clang_parser.cpp
-  codegen.cpp
   main.cpp
+  mocks.cpp
   parser.cpp
   probe.cpp
   semantic_analyser.cpp
   tracepoint_format_parser.cpp
   utils.cpp
 
+  ${CMAKE_BINARY_DIR}/tests/codegen_includes.cpp
+
   ${CMAKE_SOURCE_DIR}/src/attached_probe.cpp
   ${CMAKE_SOURCE_DIR}/src/bpftrace.cpp
+  ${CMAKE_SOURCE_DIR}/src/btf.cpp
   ${CMAKE_SOURCE_DIR}/src/clang_parser.cpp
   ${CMAKE_SOURCE_DIR}/src/driver.cpp
   ${CMAKE_SOURCE_DIR}/src/fake_map.cpp
   ${CMAKE_SOURCE_DIR}/src/map.cpp
   ${CMAKE_SOURCE_DIR}/src/mapkey.cpp
+  ${CMAKE_SOURCE_DIR}/src/output.cpp
   ${CMAKE_SOURCE_DIR}/src/printf.cpp
   ${CMAKE_SOURCE_DIR}/src/resolve_cgroupid.cpp
   ${CMAKE_SOURCE_DIR}/src/tracepoint_format_parser.cpp
   ${CMAKE_SOURCE_DIR}/src/types.cpp
   ${CMAKE_SOURCE_DIR}/src/utils.cpp
+  ${CMAKE_SOURCE_DIR}/src/disasm.cpp
+  ${BFD_DISASM_SRC}
 )
 
 if(HAVE_NAME_TO_HANDLE_AT)
@@ -37,6 +59,23 @@
 if(HAVE_BCC_CREATE_MAP)
   target_compile_definitions(bpftrace_test PRIVATE HAVE_BCC_CREATE_MAP)
 endif(HAVE_BCC_CREATE_MAP)
+if(HAVE_GET_CURRENT_CGROUP_ID)
+  target_compile_definitions(bpftrace PRIVATE HAVE_GET_CURRENT_CGROUP_ID)
+endif(HAVE_GET_CURRENT_CGROUP_ID)
+if (LIBBPF_BTF_DUMP_FOUND)
+  target_compile_definitions(bpftrace_test PRIVATE HAVE_LIBBPF_BTF_DUMP)
+  target_include_directories(bpftrace_test PUBLIC ${LIBBPF_INCLUDE_DIRS})
+  target_link_libraries(bpftrace_test ${LIBBPF_LIBRARIES})
+endif(LIBBPF_BTF_DUMP_FOUND)
+if(HAVE_BFD_DISASM)
+  target_compile_definitions(bpftrace_test PRIVATE HAVE_BFD_DISASM)
+  if(LIBBFD_DISASM_FOUR_ARGS_SIGNATURE)
+    target_compile_definitions(bpftrace_test PRIVATE LIBBFD_DISASM_FOUR_ARGS_SIGNATURE)
+  endif(LIBBFD_DISASM_FOUR_ARGS_SIGNATURE)
+  target_link_libraries(bpftrace_test ${LIBBFD_LIBRARIES})
+  target_link_libraries(bpftrace_test ${LIBOPCODES_LIBRARIES})
+endif(HAVE_BFD_DISASM)
+
 target_link_libraries(bpftrace_test arch ast parser resources)
 
 if (STATIC_LINKING)
@@ -84,9 +123,37 @@
 configure_file(parser.py parser.py COPYONLY)
 configure_file(utils.py utils.py COPYONLY)
 file(GLOB runtime_tests runtime/*)
+list(REMOVE_ITEM runtime_tests ${CMAKE_CURRENT_SOURCE_DIR}/runtime/scripts)
+list(REMOVE_ITEM runtime_tests ${CMAKE_CURRENT_SOURCE_DIR}/runtime/outputs)
 file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/runtime/)
 foreach(runtime_test ${runtime_tests})
   configure_file(${runtime_test} ${CMAKE_CURRENT_BINARY_DIR}/runtime/ COPYONLY)
 endforeach()
+file(GLOB runtime_test_scripts runtime/scripts/*)
+file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/runtime/scripts)
+foreach(runtime_test_script ${runtime_test_scripts})
+  configure_file(${runtime_test_script} ${CMAKE_CURRENT_BINARY_DIR}/runtime/scripts/ COPYONLY)
+endforeach()
+file(GLOB runtime_test_outputs runtime/outputs/*)
+file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/runtime/outputs)
+foreach(runtime_test_output ${runtime_test_outputs})
+  configure_file(${runtime_test_output} ${CMAKE_CURRENT_BINARY_DIR}/runtime/outputs/ COPYONLY)
+endforeach()
 add_custom_target(runtime-tests COMMAND ./runtime-tests.sh)
 add_test(NAME runtime_test COMMAND ./runtime-tests.sh)
+
+# Compile all testprograms, one per .c file for runtime testing
+file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/testprogs/)
+file(GLOB testprogs testprogs/*.c)
+foreach(testprog ${testprogs})
+  get_filename_component(bin_name ${testprog} NAME_WE)
+  add_executable (${bin_name} ${testprog})
+  if(HAVE_SYSTEMTAP_SYS_SDT_H)
+    target_compile_definitions(${bin_name} PRIVATE HAVE_SYSTEMTAP_SYS_SDT_H)
+  endif(HAVE_SYSTEMTAP_SYS_SDT_H)
+  set_target_properties( ${bin_name} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/testprogs/ COMPILE_FLAGS "-g -O0")
+endforeach()
+
+configure_file(tools-parsing-test.sh tools-parsing-test.sh COPYONLY)
+add_custom_target(tools-parsing-test COMMAND ./tools-parsing-test.sh)
+add_test(NAME tools-parsing-test COMMAND ./tools-parsing-test.sh)
