=== debian/changelog ===
bpftrace (0.9.3-2) unstable; urgency=medium

  * Source-only rebuild.

 -- Vincent Bernat <bernat@debian.org>  Sun, 12 Jan 2020 08:13:51 +0100

bpftrace (0.9.3-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Bernat <bernat@debian.org>  Fri, 27 Dec 2019 09:16:59 +0100

bpftrace (0.9.2-3) unstable; urgency=medium

  * d/control: switch to clang 9. Closes: #947436.

 -- Vincent Bernat <bernat@debian.org>  Fri, 27 Dec 2019 09:10:54 +0100

bpftrace (0.9.2-2) unstable; urgency=medium

  * Bump version to rebuild against newer version of libbpfcc.

 -- Vincent Bernat <bernat@debian.org>  Tue, 05 Nov 2019 08:22:07 +0100
