=== src/CMakeLists.txt ===
--- 
+++ 
@@ -4,9 +4,11 @@
 
 add_executable(bpftrace
   attached_probe.cpp
+  bpffeature.cpp
   bpftrace.cpp
   btf.cpp
   clang_parser.cpp
+  disasm.cpp
   driver.cpp
   fake_map.cpp
   list.cpp
@@ -16,10 +18,11 @@
   output.cpp
   printf.cpp
   resolve_cgroupid.cpp
+  signal.cpp
+  struct.cpp
   tracepoint_format_parser.cpp
   types.cpp
   utils.cpp
-  disasm.cpp
   ${BFD_DISASM_SRC}
 )
 
@@ -35,9 +38,6 @@
 if(HAVE_BCC_ELF_FOREACH_SYM)
   target_compile_definitions(bpftrace PRIVATE HAVE_BCC_ELF_FOREACH_SYM)
 endif(HAVE_BCC_ELF_FOREACH_SYM)
-if(HAVE_GET_CURRENT_CGROUP_ID)
-  target_compile_definitions(bpftrace PRIVATE HAVE_GET_CURRENT_CGROUP_ID)
-endif(HAVE_GET_CURRENT_CGROUP_ID)
 if (LIBBPF_BTF_DUMP_FOUND)
   target_compile_definitions(bpftrace PRIVATE HAVE_LIBBPF_BTF_DUMP)
   target_include_directories(bpftrace PUBLIC ${LIBBPF_INCLUDE_DIRS})
@@ -48,31 +48,61 @@
   if(LIBBFD_DISASM_FOUR_ARGS_SIGNATURE)
     target_compile_definitions(bpftrace PRIVATE LIBBFD_DISASM_FOUR_ARGS_SIGNATURE)
   endif(LIBBFD_DISASM_FOUR_ARGS_SIGNATURE)
-  target_link_libraries(bpftrace ${LIBBFD_LIBRARIES})
-  target_link_libraries(bpftrace ${LIBOPCODES_LIBRARIES})
+  if(STATIC_LINKING)
+    add_library(LIBBFD STATIC IMPORTED)
+    set_property(TARGET LIBBFD PROPERTY IMPORTED_LOCATION ${LIBBFD_LIBRARIES})
+    target_link_libraries(bpftrace LIBBFD)
+    add_library(LIBOPCODES STATIC IMPORTED)
+    set_property(TARGET LIBOPCODES PROPERTY IMPORTED_LOCATION ${LIBOPCODES_LIBRARIES})
+    target_link_libraries(bpftrace LIBOPCODES)
+    add_library(LIBIBERTY STATIC IMPORTED)
+    set_property(TARGET LIBIBERTY PROPERTY IMPORTED_LOCATION ${LIBIBERTY_LIBRARIES})
+    target_link_libraries(bpftrace LIBIBERTY)
+  else()
+    target_link_libraries(bpftrace ${LIBBFD_LIBRARIES})
+    target_link_libraries(bpftrace ${LIBOPCODES_LIBRARIES})
+  endif(STATIC_LINKING)
 endif(HAVE_BFD_DISASM)
 
-if (ALLOW_UNSAFE_UPROBE)
-  target_compile_definitions(bpftrace PRIVATE HAVE_UNSAFE_UPROBE)
-endif(ALLOW_UNSAFE_UPROBE)
+if (ALLOW_UNSAFE_PROBE)
+  target_compile_definitions(bpftrace PRIVATE HAVE_UNSAFE_PROBE)
+endif(ALLOW_UNSAFE_PROBE)
 
 target_link_libraries(bpftrace arch ast parser resources)
 
-if (STATIC_LINKING)
+if(STATIC_LINKING)
   target_link_libraries(bpftrace ${LIBBCC_LIBRARIES})
   target_link_libraries(bpftrace ${LIBBPF_LIBRARY_STATIC})
   target_link_libraries(bpftrace ${LIBBCC_LOADER_LIBRARY_STATIC})
+
+  add_library(LIBELF STATIC IMPORTED)
+  set_property(TARGET LIBELF PROPERTY IMPORTED_LOCATION ${LIBELF_LIBRARIES})
+  target_link_libraries(bpftrace LIBELF)
+
+  if(NOT STATIC_LIBC)
+    set_target_properties(bpftrace PROPERTIES LINK_FLAGS "${EMBEDDED_LINK_FLAGS}")
+  endif()
 else()
   target_link_libraries(bpftrace ${LIBBCC_LIBRARIES})
+  target_link_libraries(bpftrace ${LIBELF_LIBRARIES})
+endif(STATIC_LINKING)
+
+if (BUILD_ASAN)
+  if(${CMAKE_VERSION} VERSION_LESS "3.13.0")
+    # target_link_options is supported in CMake 3.13 and newer
+    message("Please use CMake 3.13 or newer to enable ASAN")
+  endif()
+  target_compile_definitions(bpftrace PRIVATE BUILD_ASAN)
+  target_compile_options(bpftrace PUBLIC "-fsanitize=address")
+  target_link_options(bpftrace PUBLIC "-fsanitize=address")
 endif()
-target_link_libraries(bpftrace ${LIBELF_LIBRARIES})
 
 install(TARGETS bpftrace DESTINATION bin)
 
 set(KERNEL_HEADERS_DIR "" CACHE PATH "Hard-code kernel headers directory")
 if (KERNEL_HEADERS_DIR)
-MESSAGE(STATUS "Using KERNEL_HEADERS_DIR=${KERNEL_HEADERS_DIR}")
-target_compile_definitions(bpftrace PUBLIC KERNEL_HEADERS_DIR="${KERNEL_HEADERS_DIR}")
+  MESSAGE(STATUS "Using KERNEL_HEADERS_DIR=${KERNEL_HEADERS_DIR}")
+  target_compile_definitions(bpftrace PUBLIC KERNEL_HEADERS_DIR="${KERNEL_HEADERS_DIR}")
 endif()
 
 execute_process(
