=== debian/changelog ===
bpftrace (0.9.4-1) unstable; urgency=medium

  * New upstream version.

 -- Vincent Bernat <bernat@debian.org>  Thu, 27 Feb 2020 22:50:17 +0100
