=== debian/control ===
--- 
+++ 
@@ -4,17 +4,17 @@
 Maintainer: Vincent Bernat <bernat@debian.org>
 Standards-Version: 4.3.0
 Build-Depends: bison,
-               clang-7,
+               clang-9,
                cmake,
                debhelper (>= 11),
                flex,
                libbpfcc-dev,
-               libclang-7-dev,
+               libclang-9-dev,
                libelf-dev,
                libfl-dev,
                libgmock-dev,
                libgtest-dev,
-               llvm-7-dev,
+               llvm-9-dev,
                zlib1g-dev
 Homepage: https://github.com/iovisor/bpftrace
 Vcs-Git: https://salsa.debian.org/debian/bpftrace.git
