=== debian/changelog ===
bpftrace (0.11.0-1) unstable; urgency=medium

  * New upstream version.
  * d/rules: delete empty /usr/share/bpftrace/tools
  * d/rules: don't rename bpftrace manual page
  * d/patches: ensure BEGIN_trigger symbol is not stripped

 -- Vincent Bernat <bernat@debian.org>  Fri, 24 Jul 2020 09:14:50 +0200

bpftrace (0.10.0-1) unstable; urgency=medium

  * New upstream version.
  * d/rules: upstream now puts man pages in their expected locations.

 -- Vincent Bernat <bernat@debian.org>  Mon, 11 May 2020 08:41:18 +0200
